/*!
 * Consistent.js 0.9.7
 * @author Karl von Randow
 * @license Apache License, Version 2.0
 */
(function(e,t){var n=e.Consistent=function(){var e=arguments[0];if(e!==t){if(n.isScope(e)){if(arguments[1]!==t){return n.createScope(e,arguments[1])}else{return n.createScope(e,null)}}else if(e.nodeName!==t){return n.findScopeForNode(e)}else if(typeof e==="object"){return n.createScope(null,e)}else if(typeof e==="string"){return n.findScopeByName(e)}else{throw j("Unexpected argument to Consistent(): "+e)}}else{return n.createScope(null,null)}};var i={};var r={};var s="ConsistentScope";var o=function(){var e={};var t=document.createElement("div");t.setAttribute("className","test");e.badGetSetAttribute=t.className==="test";e.needChangeEventForActiveOnSubmit=e.needAggressiveChangeHandlingOnInputElements=!!document.createEventObject;return e}();c(n,{settings:{attributes:{key:["data-ct","ct"],show:["data-ct-show","ct-show"],hide:["data-ct-hide","ct-hide"],enabled:["data-ct-enabled","ct-enabled"],disabled:["data-ct-disabled","ct-disabled"],readOnly:["data-ct-readonly","ct-readonly"],readWrite:["data-ct-readwrite","ct-readwrite"],options:["data-ct-options","ct-options"],template:["data-ct-tmpl","ct-tmpl"],templateId:["data-ct-tmpl-id","ct-tmpl-id"],attributes:["data-ct-attrs","ct-attrs"],attributePrefix:["data-ct-attr-","ct-attr-"],properties:["data-ct-props","ct-props"],propertyPrefix:["data-ct-prop-","ct-prop-"],templateAttributePrefix:["data-ct-tmpl-attr-","ct-tmpl-attr-"],templateIdAttributePrefix:["data-ct-tmpl-id-attr-","ct-tmpl-id-attr-"],classAttribute:["data-ct-class","ct-class"],classAddAttribute:["data-ct-add-class","ct-add-class"],on:["data-ct-on","ct-on"],onPrefix:["data-ct-on-","ct-on-"],repeat:["data-ct-repeat","ct-repeat"],repeatContainerId:["data-ct-repeat-container-id","ct-repeat-container-id"],noBind:["data-ct-nobind","ct-nobind"],scope:["data-ct-scope","ct-scope"],init:["data-ct-init","ct-init"],initFunc:["data-ct-init-func","ct-init-func"],warningPrefix:["data-ct-","ct-"]},scopeIdKey:"__ConsistentScopeID",functionIdKey:"__ConsistentFunctionID",oldDisplayKey:"__ConsistentOldDisplay",addedClassesKey:"__ConsistentAddedClasses",maxWatcherLoops:100,autoCreateScopes:true},isScope:function(e){return e!==t&&e.$!==t&&e.$._type===s},createScope:function(e,t){t=p({},n.defaultOptions,t);var s=new P(e,t);i[s._id]=s;if(s._name){r[s._name]=s}return s._scope},autoCreateScopes:function(){var t=document;var i=n.settings.attributes.scope;var r=n.settings.attributes.init;var s=n.settings.attributes.initFunc;var o=i.length;var a=r.length;var f=s.length;l(t);function l(t){var u;var c;if(t.getAttribute){for(c=0;c<o;c++){u=t.getAttribute(i[c]);if(typeof u==="string"){break}}}if(typeof u==="string"){var p=n.createScope(null,u?{name:u}:null);p.$.bind(t);var d=false;var v;for(c=0;c<a;c++){var g=t.getAttribute(r[c]);if(g){if(g==="update"){break}else if(g==="none"){d=true;break}else if(g){d=true;v=n.statementToFunction(g);m(v,p);p.$.apply();break}}}if(!d){for(c=0;c<f;c++){var y=t.getAttribute(s[c]);if(y){v=h(e,y);if(v){v.call(p)}else{throw j("Consistent scope init function attribute referenced a function that was not found: "+y)}}}}if(!d){p.$.update();p.$.apply()}}else{var b=t.firstChild;while(b!==null){if(b.nodeType===1){l(b)}b=b.nextSibling}}}},destroyScope:function(e){var t=e.$._manager();t.destroy();delete i[t._id];if(t._name){delete r[t._name]}},findScope:function(e){var t=r[e];if(t){return t._scope}else{return null}},findScopeForNode:function(e){var t=e[n.settings.scopeIdKey];if(t&&i[t]){return i[t]._scope}else{return null}},expressionToFunction:function(e){throw j("Expression support requires consistent-expressions.js")},statementToFunction:function(e){throw j("Expression support requires consistent-expressions.js")},merge:c});var a={};function f(e){return a.toString.call(e)==="[object Array]"}function l(e){for(var t in e){return false}return true}var u;if(typeof[].indexOf==="function"){u=function(e,t,n){return e.indexOf(t,n)}}else{u=function(e,n,i){if(i===t){i=0}if(i<0){i+=e.length;if(i<0){i=0}}for(var r=i;r<e.length;r++){if(e[r]===n){return r}}return-1}}function c(){var e=[];var n=[];function i(){var r=0;var s=false;if(typeof arguments[0]==="boolean"){s=arguments[0];r++}var o=arguments[r];if(typeof o!=="object"&&typeof o!=="function"){throw j("Target object argument to merge is not appropriate: "+typeof o)}if(o===null){throw j("Target object argument to merge is not appropriate: "+o)}for(var a=r+1;a<arguments.length;a++){var l=arguments[a];if(l===t){continue}if(typeof l!=="object"&&typeof l!=="function"){throw j("Argument "+(a+1)+" to merge is not appropriate: "+typeof l)}e.push(l);n.push(o);for(var c in l){if(c==="$"){continue}var p=l[c];if(p!==t){if(s&&typeof p==="object"&&p!==null){var d=u(e,p);if(d===-1){var h=o[c];if(h===t){h=f(p)?[]:{}}p=i(true,h,p)}else{p=n[d]}}o[c]=p}}}return o}return i.apply(this,arguments)}function p(){var e=[];for(var t=0;t<arguments.length;t++){var n=arguments[t];if(n){e.push(arguments[t].$)}}if(!e[0]){e[0]={}}var i=c.apply(this,arguments);i.$=c.apply(this,e);return i}function d(e){if(!o.badGetSetAttribute){return e}if(e==="class"){return"className"}else{return e}}function h(e,n){var i=n.split(".");var r=e;var s;for(s=0;s<i.length&&r!==t&&r!==null;s++){if(i[s]==="constructor"){throw j("Illegal attempt to access 'constructor' keyword for property: "+n)}if(r&&r.constructor===r){throw j("Illegal attempt to access Function constructor for property: "+n)}r=r[i[s]]}if(s===i.length){if(r&&r.constructor===r){throw j("Illegal attempt to access Function constructor for property: "+n)}return r}else{return t}}function v(e,n){if(n===t){n=""}var i=[];for(var r in e){if(typeof e[r]==="object"&&e[r]!==null){i=i.concat(v(e[r],n+r+"."))}else{i.push(n+r)}}return i}function g(e,n,i){var r=n.split(".");var s=e;for(var o=0;o<r.length-1;o++){if(s[r[o]]===t){s[r[o]]={}}s=s[r[o]]}s[r[r.length-1]]=i}function y(e){var t=e.value;if(!t){t=e.text}return t}function b(e,t){return e({get:function(e){return h(t,e)}})}function m(e,t){return e({get:function(e){return t.$.get(e)},set:function(e,n){return t.$.set(e,n)}})}n.defaultOptions={templateEngine:null,autoListenToChange:true,autoListenToKeyEvents:true,eventHandlerPrefix:"$",valueFunctionPrefix:"",$:{getNodeOptions:function(e,t){return n.getNodeOptions(e,t)},apply:function(e,n,i){var r,s,o;var a=i.bindings;if(a.selectOptions){s=h(n,a.selectOptions);if(s!==t){if(!s){s=[]}var l=e.selectedIndex!==-1?y(e.options[e.selectedIndex]):t;e.length=s.length;for(o=0;o<s.length;o++){var u;if(typeof s[o]==="object"){var c=s[o].text;var p=s[o].value;u=new Option(c!==t?c:"",p!==t?p:"",false,p==l);if(s[o].label!==t){u.label=s[o].label}if(s[o].disabled!==t){u.disabled=!!s[o].disabled}}else{u=new Option(s[o],s[o],false,s[o]==l)}e.options[o]=u}}}if(a.key){s=x(a.key);if(s!==t){this.setValue(e,s)}}else if(a.template!==t&&a.template!==null){this.setValue(e,a.template.render(n))}if(a.attributes){var d=a.attributes;for(o=0;o<d.length;o++){if(d[o].key!==t){s=x(d[o].key)}else if(d[o].template!==t){s=d[o].template.render(n)}else{s=null}if(s!==t){this.setAttributeValue(e,d[o].name,s)}}}if(a.allAttributes){s=h(n,a.allAttributes);for(r in s){if(s[r]!==t){s=s[r];if(r==="className"){r="class"}this.setAttributeValue(e,r,s)}}}if(a.classAttribute){s=x(a.classAttribute);if(s!==t){if(f(s)){s=s.join(" ")}this.setAttributeValue(e,"class",s)}}if(a.classAddAttribute){s=x(a.classAddAttribute);if(s!==t){this.addRemoveClasses(e,s)}}if(a.properties){var g=a.properties;for(o=0;o<g.length;o++){s=x(g[o].key);if(s!==t){this.setPropertyValue(e,g[o].name,s)}}}if(a.allProperties){s=h(n,a.allProperties);var m=v(s);for(o=0;o<m.length;o++){var _=h(s,m[o]);if(_!==t){this.setPropertyValue(e,m[o],_)}}}if(a.show){s=x(a.show);if(s!==t){if(s){this.show(e)}else{this.hide(e)}}}if(a.hide){s=x(a.hide);if(s!==t){if(!s){this.show(e)}else{this.hide(e)}}}if(a.enabled){s=x(a.enabled);if(s!==t){this.setPropertyValue(e,"disabled",!s)}}if(a.disabled){s=x(a.disabled);if(s!==t){this.setPropertyValue(e,"disabled",!!s)}}if(a.readOnly){s=x(a.readOnly);if(s!==t){this.setPropertyValue(e,"readOnly",!!s)}}if(a.readWrite){s=x(a.readWrite);if(s!==t){this.setPropertyValue(e,"readOnly",!s)}}function x(e){if(typeof e==="function"){return b(e,n)}else{return h(n,e)}}},afterApply:function(e,t){},setValue:function(e,t){var n=this.getValue(e);if(n===t){return}var i=e.nodeName;if(i==="INPUT"||i==="TEXTAREA"){if(e.type==="checkbox"){if(f(t)){e.checked=e.defaultChecked=u(t,e.value)!==-1}else if(typeof t==="boolean"){e.checked=e.defaultChecked=t}else{e.checked=e.defaultChecked=t==e.value}}else if(e.type==="radio"){e.checked=e.defaultChecked=t==e.value}else{if(t===null){t=""}e.value=t}}else if(i==="SELECT"){if(t===null){t=""}var r;if(f(t)){for(r=0;r<e.options.length;r++){e.options[r].selected=u(t,y(e.options[r]))!==-1}}else{for(r=0;r<e.options.length;r++){if(y(e.options[r])==t){e.selectedIndex=r;return}}e.selectedIndex=-1}}else if(i==="IMG"){e.src=t}else{e.innerHTML=t}},setAttributeValue:function(e,t,n){t=d(t);if(n){e.setAttribute(t,n)}else{e.removeAttribute(t)}},setPropertyValue:function(e,t,n){g(e,t,n)},update:function(e,n,i){var r,s;var o=i.bindings;if(y(o.selectOptions)){var a=e.options;r=[];for(s=0;s<a.length;s++){var l=a[s];r.push({text:l.text,value:l.value,label:l.label,disabled:l.disabled})}n.$.set(o.selectOptions,r)}if(y(o.key)){r=this.getValue(e);if(r!==t){if(e.nodeName==="INPUT"&&e.type==="checkbox"){var c=n.$.get(o.key);if(f(c)){s=u(c,e.value);if(r){if(s===-1){c.push(e.value)}}else{if(s!==-1){c.splice(s,1)}}}else if(e.value!=="on"&&(c===t||c===null)){if(r){n.$.set(o.key,e.value)}}else if(typeof c==="boolean"||e.value==="on"){n.$.set(o.key,r)}else if(r&&c!==e.value){n.$.set(o.key,[c,e.value])}}else{n.$.set(o.key,r)}}}if(y(o.attributes)){var p=o.attributes;for(s=0;s<p.length;s++){if(p[s].key!==t){r=this.getAttributeValue(e,p[s].name);n.$.set(p[s].key,r)}}}if(y(o.allAttributes)){r=n.$.get(o.allAttributes);if(r!==t){for(s in r){r[s]=this.getAttributeValue(e,s)}n.$.set(o.allAttributes,r)}}if(y(o.classAttribute)){r=this.getAttributeValue(e,"class");if(f(n.$.get(o.classAttribute))){r=r.split(" ")}n.$.set(o.classAttribute,r)}if(y(o.properties)){var d=o.properties;for(s=0;s<d.length;s++){r=this.getPropertyValue(e,d[s].name);n.$.set(d[s].key,r)}}if(y(o.allProperties)){r=n.$.get(o.allProperties);if(r!==t){var h=v(r);for(s=0;s<h.length;s++){g(r,h[s],this.getPropertyValue(e,h[s]))}n.$.set(o.allProperties,r)}}if(y(o.show)){r=this.isShowing(e);n.$.set(o.show,r)}if(y(o.hide)){r=this.isShowing(e);n.$.set(o.hide,!r)}if(y(o.enabled)){r=this.getPropertyValue(e,"disabled");n.$.set(o.enabled,!r)}if(y(o.disabled)){r=this.getPropertyValue(e,"disabled");n.$.set(o.disabled,r)}if(y(o.readOnly)){r=this.getPropertyValue(e,"readOnly");n.$.set(o.readOnly,r)}if(y(o.readWrite)){r=this.getPropertyValue(e,"readOnly");n.$.set(o.readWrite,!r)}function y(e){return e&&typeof e!=="function"}},getValue:function(e){var n=e.nodeName;if(n==="INPUT"||n==="TEXTAREA"){if(e.type==="checkbox"){return e.checked}else if(e.type==="radio"){return e.checked?e.value:t}else{return e.value}}else if(n==="SELECT"){if(e.multiple){var i=[];for(var r=0;r<e.options.length;r++){if(e.options[r].selected){i.push(y(e.options[r]))}}return i}else if(e.selectedIndex!==-1){return y(e.options[e.selectedIndex])}else{return t}}else if(n==="IMG"){return e.src}else{return e.innerHTML}},getAttributeValue:function(e,t){t=d(t);return e.getAttribute(t)},getPropertyValue:function(e,t){return h(e,t)},addRemoveClasses:function(e,t){var i=p(t);var r=p(this.getAttributeValue(e,"class"));var s=e[n.settings.addedClassesKey];if(!s){s=[];e[n.settings.addedClassesKey]=s}var o,a,l;for(o=0;o<s.length;o++){a=u(i,s[o]);if(a===-1){l=u(r,s[o]);if(l!==-1){r.splice(l,1)}s.splice(o,1);o--}}for(o=0;o<i.length;o++){var c=i[o];a=u(s,c);if(a===-1){l=u(r,c);if(l===-1){r.push(c);s.push(c)}}}this.setAttributeValue(e,"class",r.join(" "));function p(e){if(e===null||!e){return[]}else if(typeof e==="string"){return e.split(" ")}else if(f(e)){return e}else{throw j("Unsupported value for add class: "+typeof e)}}},show:function(e){if(e.style.display!=="none"){return}var i=e[n.settings.oldDisplayKey];if(i===t){i=""}e.style.display=i},hide:function(e){if(e.style.display==="none"){return}e[n.settings.oldDisplayKey]=e.style.display;e.style.display="none"},isShowing:function(e){return e.style.display!=="none"},added:function(e){},remove:function(e){e.parentNode.removeChild(e)}}};n.getNodeOptions=n.defaultGetNodeOptions=function(e,i){var r=p({bindings:{}},i);var s=r.bindings;var o=e.nodeName;if(o==="INPUT"||o==="TEXTAREA"||o==="SELECT"){if(s.key===t){s.key=e.getAttribute("name")}}var a=n.settings;var l=e.attributes;if(l===t){throw j("Unexpected object, expected DOM node: "+e)}for(var u=0;u<l.length;u++){var c=l[u].name;var d=v(c);if(d){var h=A(l[u].value);if(!h&&d.name!=="noBind"){continue}switch(d.name){case"key":{s.key=k(h);break}case"attributePrefix":{m(d.suffix,k(h));break}case"attributes":{s.allAttributes=h;break}case"template":{g();s.template=i.templateEngine.compile(h);break}case"templateId":{g();s.template=i.templateEngine.compile(y(h));break}case"templateAttributePrefix":{g();_(d.suffix,i.templateEngine.compile(h));break}case"templateIdAttributePrefix":{g();_(d.suffix,i.templateEngine.compile(y(h)));break}case"propertyPrefix":{x(d.suffix.replace(/-/g,"."),k(h));break}case"properties":{s.allProperties=h;break}case"on":{w($(e),N(h));break}case"onPrefix":{w(d.suffix.toLowerCase(),N(h));break}case"show":{s.show=k(h);break}case"hide":{s.hide=k(h);break}case"repeat":{s.repeat=h;break}case"repeatContainerId":{s.repeatContainerId=h;break}case"enabled":{s.enabled=k(h);break}case"disabled":{s.disabled=k(h);break}case"readOnly":{s.readOnly=k(h);break}case"readWrite":{s.readWrite=k(h);break}case"options":{s.selectOptions=h;break}case"classAttribute":{s.classAttribute=k(h);break}case"classAddAttribute":{s.classAddAttribute=k(h);break}case"noBind":{s.noBind=!h||h==="true";break}case"scope":case"init":case"initFunc":{break}case"warningPrefix":{if(typeof console!=="undefined"&&console.log!==t){console.log('Warning: Unrecognised Consistent attribute "'+c+'" on '+e.nodeName+" element.")}break}default:{throw j("Unhandled consistent declaration attribute: "+c)}}}}function v(e){for(var t in a.attributes){var n=a.attributes[t];var i;var r=t.lastIndexOf("Prefix");if(r!==-1&&r===t.length-"Prefix".length){if(f(n)){for(i=0;i<n.length;i++){if(e.indexOf(n[i])===0){return{name:t,suffix:e.substring(n[i].length)}}}}else if(e.indexOf(n)===0){return{name:t,suffix:e.substring(n.length)}}}else{if(f(n)){for(i=0;i<n.length;i++){if(e===n[i]){return{name:t}}}}else if(e===n){return{name:t}}}}return false}function g(){if(!i.templateEngine){throw j("templateEngine not configured in options")}}function y(e){var t=document.getElementById(e);if(t!==null){return t.innerHTML}else{throw j("Template not found with id: "+e)}}function b(){if(s.attributes===t){s.attributes=[]}}function m(e,t){b();s.attributes.push({name:e,key:t})}function _(e,t){b();s.attributes.push({name:e,template:t})}function x(e,n){if(s.properties===t){s.properties=[]}s.properties.push({name:e,key:n})}function w(e,n){if(s.events===t){s.events={}}if(s.events[e]===t){s.events[e]={keys:[]}}s.events[e].keys.push(n)}function $(e){var t=e.nodeName;if(t==="INPUT"||t==="TEXTAREA"||t==="SELECT"){return"change"}else if(t==="FORM"){return"submit"}else{return"click"}}function A(e){return e.replace(/^\s*(.*)\s*$/,"$1")}function S(e){return e.match(/^[a-zA-Z_$][a-zA-Z_$0-9\.]*$/)}function k(e){if(S(e)){return e}else{return n.expressionToFunction(e)}}function N(e){if(S(e)){return e}else{return n.statementToFunction(e)}}return r};function _(e,n,i,r,s){if(s===t){s=[]}if(u(s,e)!==-1){return}s.push(e);var o=r.$.options();var a=o.eventHandlerPrefix;var f=o.valueFunctionPrefix;var l;var c=[];for(var p in e){if(u(c,p)!==-1){continue}if(p.indexOf(a)===0){if(n){l=w(p,a);if(l===p||e[l]===t){e[l]=e[p]}if(l!==p){delete e[p];c.push(l)}}else{delete e[p]}}else if(typeof e[p]==="function"){if(!f){e[p]=e[p].call(i)}else if(p.indexOf(f)===0){l=w(p,f);e[l]=e[p].call(i);delete e[p];if(l!==p){c.push(l)}}}else if(typeof e[p]==="object"&&e[p]!==null){_(e[p],n,i,r,s)}}}n.defaultEmptyScope={$:{_type:s,_scope:null,_manager:null,index:t,apply:function(e,n,i){if(typeof e==="function"){if(typeof n==="boolean"){i=n;n=t}n=e;e=t}else if(typeof e==="boolean"){i=e;e=t}else if(typeof n==="boolean"){i=n;n=t}var r=this._scope();if(n!==t){n.call(r,e,i)}this._manager().apply(e,i);return r},applyLater:function(n,i,r){if(typeof n==="function"){if(typeof i==="boolean"){r=i;i=t}i=n;n=t}else if(typeof n==="boolean"){r=n;n=t}else if(typeof i==="boolean"){r=i;i=t}var s=this._scope();if(i!==t){i.call(s,n,r)}e.clearTimeout(this._applyLaterTimeout);this._applyLaterTimeout=e.setTimeout(function(){s.$.apply(n,r)},0);return s},needsApply:function(){return this._manager().needsApply()},update:function(e,t){this._manager().update(e,t);return this._scope()},bind:function(e,t){this._manager().bind(e,t);return this._scope()},unbind:function(e){this._manager().unbind(e);return this._scope()},merge:function(e,n){var i=this._scope();if(typeof e==="boolean"){return c(e,i,n)}else if(n===t){return c(i,e)}else if(f(n)){for(var r=0;r<n.length;r++){g(i,n[r],h(e,n[r]))}return i}else if(typeof n!=="object"){g(i,n,h(e,n));return i}else{throw j("Invalid keys argument to merge: "+n)}},replace:function(e){return this._manager().replaceScope(e)},clear:function(){var e=this._scope();for(var t in e){if(t!=="$"){delete e[t]}}},model:function(e,n){if(e!==t&&typeof e!=="boolean"){throw j("Invalid type for includeParents: "+typeof e)}var i=this._scope();var r=c(true,{},i);_(r,false,n!==t?n:i,i);if(e!==false&&this.parent()){r=c(this.parent().$.model(e,n!==t?n:i),r)}return r},snapshot:function(e,n){if(e!==t&&typeof e!=="boolean"){throw j("Invalid type for includeParents: "+typeof e)}var i=this._scope();var r=c(true,{},i);_(r,true,n!==t?n:i,i);if(e!==false&&this.parent()){r=c(this.parent().$.snapshot(e,n!==t?n:i),r)}return r},nodes:function(e){if(e!==t&&typeof e!=="boolean"){throw j("Invalid type for includeParents: "+typeof e)}var n=this._manager()._domNodes;if(e!==false){var i=this.children();for(var r=0;r<i.length;r++){n=n.concat(i[r].$.nodes())}}return n},roots:function(){return this._manager()._rootDomNodes},parent:function(){var e=this._manager()._parentScopeManager;if(e!==null){return e._scope}else{return null}},children:function(){var e=[];var t=this._manager()._childScopeManagers;for(var n=0;n<t.length;n++){e.push(t[n]._scope)}return e},watch:function(e,t){this._manager().watch(e,t);return this._scope()},unwatch:function(e,t){this._manager().unwatch(e,t);return this._scope()},get:function(e,n){if(n!==t&&typeof n!=="boolean"){throw j("Invalid type for includeParents: "+typeof n)}if(e==="$"||e.substring(0,2)==="$."){return t}var i=this.options().valueFunctionPrefix;var r=this._scope();var s=h(r,e);if(s!==t){if(!i&&typeof s==="function"){return s.call(r)}else{return s}}else{var o;if(i){o=x(e,i);s=h(r,o);if(typeof s==="function"){return s.call(r)}}o=x(e,this.options().eventHandlerPrefix);s=h(r,o);if(typeof s==="function"){return s}}if(n!==false&&this.parent()){return this.parent().$.get(e)}else{return t}},set:function(e,n){var i=this._scope();var r=h(i,e);if(typeof r==="undefined"){var s=this.getValueFunction(e);if(s!==t){s.call(i,n);return i}}if(typeof r!=="function"){g(i,e,n)}else if(!this.options().valueFunctionPrefix){r.call(i,n)}else{g(i,e,n)}return i},getEventHandler:function(e,n){if(n!==t&&typeof n!=="boolean"){throw j("Invalid type for includeParents: "+typeof n)}var i=this._scope();var r=this.options().eventHandlerPrefix;var s=h(i,x(e,r));if(s!==t){if(typeof s==="function"){return s}else{return t}}else if(n!==false&&this.parent()){return this.parent().$.getEventHandler(e)}else{return t}},setEventHandler:function(e,t){e=x(e,this.options().eventHandlerPrefix);var n=this._scope();g(n,e,t);return n},fire:function(e,n,i){var r=this.getEventHandler(e);var s=this._scope();if(r!==t){r.call(s,n,i)}return s},getValueFunction:function(e,n){if(n!==t&&typeof n!=="boolean"){throw j("Invalid type for includeParents: "+typeof n)}var i=this._scope();var r=this.options().valueFunctionPrefix;if(r&&h(i,e)!==t){return t}var s=h(i,x(e,r));if(s!==t){if(typeof s==="function"){return s}else{return t}}else if(n!==false&&this.parent()){return this.parent().$.getValueFunction(e)}else{return t}},setValueFunction:function(e,t){e=x(e,this.options().valueFunctionPrefix);var n=this._scope();g(n,e,t);return n},options:function(e){return this._manager().getOptions(e)},evaluate:function(e){var t=n.expressionToFunction(e);var i=this.snapshot();return b(t,i)},exec:function(e){var t=n.statementToFunction(e);return m(t,this._scope())}}};function x(e,t){if(!t){return e}var n=e.split(".");var i="";for(var r=0;r<n.length-1;r++){i+=n[r]+"."}var s=n[n.length-1];if($(t)){i+=t+s.substring(0,1).toUpperCase()+s.substring(1)}else{i+=t+s}return i}function w(e,n){if(n===t){return e}if($(n)){var i=e.substring(n.length);return i.substring(0,1).toLowerCase()+i.substring(1)}else{return e.substring(n.length)}}function $(e){if(!e){return false}var t=e.charAt(e.length-1);return t>="A"&&t<="Z"||t>="a"&&t<="z"}function A(e,n,i,r,s,o){if(i===t){i=""}if(r===t){r=0}if(s===t){s=[]}if(o===t){o=[]}if(u(o,e)!==-1||u(o,n)!==-1){return s}o.push(e);o.push(n);if(e===n){return s}var a;if(n!==null){for(a in e){if(e[a]!==n[a]){if(typeof e[a]==="object"&&typeof n[a]==="object"&&e[a]&&n[a]){A(e[a],n[a],i+a+".",r+1,s,o)}else{s.push(i+a)}}}}else{for(a in e){s.push(i+a)}}for(a in n){if(e===null||e[a]===t){s.push(i+a)}}return s}function S(e,t){var n=typeof e;if(n!==typeof t){return false}if(n==="function"){return e===t}else if(n==="object"){var i=A(e,t);return i.length===0}else{return true}}function k(e,t){for(var n=0;n<t.length;n++){e.removeAttribute(t[n])}}P.prototype=new Object;var N=0;var C=0;var E="$all";function P(e,t){this._id="ConsistentScope"+N;N++;if(t.name){this._name=t.name}if(e){this._parentScopeManager=e.$._manager();this._parentScopeManager._childScopeManagers.push(this)}else{this._parentScopeManager=null}this._childScopeManagers=[];this._options=t;this._nodes=[];this._domNodes=[];this._repeatNodes=[];this._rootDomNodes=[];this._watchers={};this._nodesDirty=false;this._applying=false;this._repeatNodeScope=false;var i=this;this._scope=p({},n.defaultEmptyScope);this._scope.$._manager=function(){return i};this._scope.$._scope=function(){return i._scope};this._cleanScopeSnapshot=this._scope.$.snapshot()}P.prototype.apply=function(e,n){if(this._applying){return}this._applying=true;var i,r;if(this._updateCleanScopeAndFireWatchers()||this._nodesDirty){r=this._nodes.length;var s;for(i=0;i<r;i++){var o=this._nodes[i];s=e!==t?p({},o.options,e):o.options;s.$.apply(o.dom,this._cleanScopeSnapshot,s)}r=this._repeatNodes.length;for(i=0;i<r;i++){var a=this._repeatNodes[i];s=e!==t?p({},a.options,e):a.options;this._handleRepeat(a,s,this._cleanScopeSnapshot)}if(n!==false){var f=this._scope.$.children();for(i=0,r=f.length;i<r;i++){var l=f[i];if(l.$._manager()._repeatNodeScope){continue}l.$.apply(true)}}this._nodesDirty=false;if(this._parentScopeManager){this._parentScopeManager._scope.$.apply(e)}var u=e!==t?p({},this._options,e):this._options;u.$.afterApply(this._scope,this._cleanScopeSnapshot)}this._applying=false};P.prototype._handleRepeat=function(e,i,r){var s=i.bindings.repeat;var o;var a=this._scope.$.get(s);var f=h(r,s);if(f===t){return}if(typeof f!=="object"){throw j('Repeat for key "'+s+'" is not an object in the scope, found '+typeof f)}e.version++;var l=e.version;var u=e.insertBefore;var c=u.parentNode;var p=null;var d;var v=document.activeElement;var g=false;for(o=a.length-1;o>=0;o--){var y=a[o];d=A(y);var b=false;if(d===t){var m=S();var _=n(this._scope,this._options);_.$._manager()._repeatNodeScope=true;_.$.bind(m);_=_.$.replace(y);d={object:y,domNodes:m,scope:_,version:l};e.items.push(d);b=true}else{d.version=l}var x=d.domNodes[d.domNodes.length-1];if(b||x.nextSibling!==u){k(d.domNodes,u,c)}if(b){for(var w=0;w<d.domNodes.length;w++){i.$.added(d.domNodes[w])}}d.before=u;p=u=d.domNodes[0];d.scope.$.index=o;d.scope.$.apply()}var $=[];for(o=e.items.length-1;o>=0;o--){d=e.items[o];if(d.version!==l){k(d.domNodes,d.before,c);d.scope.$.unbind(d.domNodes);$=$.concat(d.domNodes);e.items.splice(o,1);d.scope.$.index=t}}if($.length){for(o=$.length-1;o>=0;o--){i.$.remove($[o])}}if(g&&v){v.focus()}function A(n){var i=e.items.length;for(var r=0;r<i;r++){var s=e.items[r];if(s.object===n){return s}}return t}function S(){var t=[];var n=e.domNodes.length;for(var i=0;i<n;i++){t.push(e.domNodes[i].cloneNode(true))}return t}function k(e,t,n){var i=e.length;for(var r=0;r<i;r++){var s=e[r];n.insertBefore(s,t);if(s===v){g=true}}}};P.prototype.update=function(e,n){var i,r,s;if(e===t){r=this._nodes.length;for(i=0;i<r;i++){s=this._nodes[i];s.options.$.update(s.dom,this._scope,s.options)}}else{if(f(e)||F(e)){r=e.length;for(i=0;i<r;i++){this.update(e[i],n)}}else{i=u(this._domNodes,e);if(i!==-1){s=this._nodes[i];s.options.$.update(s.dom,this._scope,s.options)}if(n){var o=e.firstChild;while(o!==null){if(o.nodeType===1){this.update(o,n)}o=o.nextSibling}}}}};P.prototype.needsApply=function(){if(this._nodesDirty){return true}return this.isDirty()};P.prototype.isDirty=function(){return A(this._scope.$.snapshot(),this._cleanScopeSnapshot).length!==0};P.prototype._updateCleanScopeAndFireWatchers=function(){var e=false;var t;var i=true;var r=0;var s=this._cleanScopeSnapshot;var o={};while(i){var a=this._scope.$.snapshot();t=[];while(i){i=false;if(r>=n.settings.maxWatcherLoops){throw j("Too many loops while notifying watchers. There is likely to be an infinite loop caused by watcher functions continously changing the scope. You may otherwise increase Consistent.settings.maxWatcherLoops if this is not the case.")}var f=A(a,s);for(var l=0;l<f.length;l++){var c=f[l];if(u(t,c)===-1){t.push(c)}i|=this._notifyWatchers(c,h(a,c),h(s,c),this._scope,o)}r++}if(t.length>0){i|=this._notifyWatchAlls(t,this._scope,a,s,o);e=true}s=a}if(e){this._cleanScopeSnapshot=this._scope.$.snapshot();return true}else{return false}};P.prototype._notifyWatchers=function(e,i,r,s,o){var a=false;var f=this._watchers[e];if(f!==t){for(var l=0;l<f.length;l++){var u=o[e];if(u===t){o[e]=u={}}var c=f[l];var p=c[n.settings.functionIdKey];if(p===t){p=c[n.settings.functionIdKey]="ConsistentFunction"+C;C++}if(u[p]===t||!S(u[p].cleanValue,i)){c.call(s,e,i,r);u[p]={cleanValue:s.$.get(e)};a=true}}}if(this._parentScopeManager){this._parentScopeManager._notifyWatchers(e,i,r,s,o)}return a};P.prototype._notifyWatchAlls=function(e,i,r,s,o){var a=false;var f=this._watchers[E];if(f!==t){for(var l=0;l<f.length;l++){var u=o[E];if(u===t){o[E]=u={}}var c=f[l];var p=c[n.settings.functionIdKey];if(p===t){p=c[n.settings.functionIdKey]="ConsistentFunction"+C;C++}if(u[p]===t||!S(r,u[p].cleanScopeSnapshot)){f[l].call(i,e,r,s);u[p]={cleanScopeSnapshot:i.$.snapshot()};a=true}}}if(this._parentScopeManager){this._parentScopeManager._notifyWatchAlls(e,i,r,s,o)}return a};function I(e,t,n){if(e.addEventListener){e.addEventListener(t,n,false)}else if(e.attachEvent){e.attachEvent("on"+t,n)}else{throw j("Unable to attach event to DOM node. Cannot find supported method.")}}function T(e){if(!e.preventDefault){e.preventDefault=function(){this.returnValue=false}}}function O(e,t){var n;if(document.createEvent){n=document.createEvent("HTMLEvents");n.initEvent(t,true,true);e.dispatchEvent(n)}else if(document.createEventObject){e.fireEvent("on"+t)}else{throw j("Unable to fire a DOM event. Cannot find supported method.")}return n}function F(e){return e.length!==t&&e.attributes===t}P.prototype.bind=function(e,i,r){var s;if(f(e)||F(e)){for(s=0;s<e.length;s++){this.bind(e[s],i,r)}return}var a;if(e[n.settings.scopeIdKey]!==this._id){a=p({},this._options,i);a=a.$.getNodeOptions(e,a);if(a.bindings.noBind){return}e[n.settings.scopeIdKey]=this._id;if(r===t){this._rootDomNodes.push(e)}if(!l(a.bindings)){if(a.bindings.repeat!==t){var u={version:0,items:[],options:a};var c=a.bindings.repeat;if(a.bindings.repeatContainerId){var d=document.getElementById(a.bindings.repeatContainerId);if(d!==null){u.domNodes=d.children}else{throw j("Couldn't find element with id \""+a.bindings.repeatContainerId+'" for repeat container.')}}else{u.domNodes=[e.cloneNode(true)]}for(s=0;s<u.domNodes.length;s++){k(u.domNodes[s],n.settings.attributes.repeat);k(u.domNodes[s],n.settings.attributes.repeatContainerId)}var h=document.createComment("Consistent repeat "+c);e.parentNode.insertBefore(h,e);e.parentNode.removeChild(e);h[n.settings.scopeIdKey]=this._id;u.insertBefore=document.createComment("/Consistent repeat "+c);h.parentNode.insertBefore(u.insertBefore,h.nextSibling);this._repeatNodes.push(u);this._nodesDirty=true}else{this._nodes.push({dom:e,options:a});this._domNodes.push(e);this._nodesDirty=true;var v=this;var g=e.nodeName;var y;if(a.autoListenToChange&&(g==="INPUT"||g==="TEXTAREA"||g==="SELECT")){y=function(t){T(t);a.$.update(e,v._scope,a);v._nodesDirty=true;v._scope.$.apply()};I(e,"change",y,false);if(o.needAggressiveChangeHandlingOnInputElements&&g==="INPUT"&&(e.type==="checkbox"||e.type==="radio")){I(e,"click",y,false)}a.$._changeListener=y}if(a.autoListenToKeyEvents&&(g==="INPUT"||g==="TEXTAREA")){y=function(t){T(t);a.$.update(e,v._scope,a);v._nodesDirty=true;v._scope.$.apply()};I(e,"keyup",y,false);a.$._keyListener=y}for(var b in a.bindings.events){(function(n,i){var r=function(r){var s;T(r);if(o.needChangeEventForActiveOnSubmit&&n==="submit"&&e.nodeName==="FORM"){for(s=0;s<e.elements.length;s++){if(document.activeElement===e.elements[s]){O(e.elements[s],"change")}}}for(s=0;s<i.length;s++){var a=i[s];var f;var l;if(typeof a==="function"){l=m(a,v._scope);if(typeof l!=="function"){r.preventDefault();v._scope.$.apply();continue}else{f=l}}if(f===t){f=v._scope.$.getEventHandler(a)}if(f!==t){if(f){l=f.call(v._scope,r,e);if(l===false)break}}else{r.preventDefault();var u=v._options.eventHandlerPrefix;throw j('Bound "'+n+'" event cannot find an event handler function in "'+x(a,u)+'"')}}};a.bindings.events[n].listener=r;I(e,n,r)})(b,a.bindings.events[b].keys)}}}}if(a===t||!a.bindings.repeat){var _=e.firstChild;while(_!==null){if(_.nodeType===1){this.bind(_,i,e)}_=_.nextSibling}}};P.prototype.unbind=function(e){var n;if(f(e)||F(e)){for(n=0;n<e.length;n++){this.unbind(e[n])}return}n=u(this._domNodes,e);if(n!==-1){var i=this._nodes[n];var r=i.options;for(var s in r.bindings.events){e.removeEventListener(s,r.bindings.events[s].listener,false)}if(r.$._changeListener!==t){e.removeEventListener("change",r.$._changeListener,false)}if(r.$._keyListener!==t){e.removeEventListener("keyup",r.$._keyListener,false)}this._domNodes.splice(n,1);this._nodes.splice(n,1)}var o=e.firstChild;while(o!==null){if(o.nodeType===1){this.unbind(o)}o=o.nextSibling}};P.prototype.watch=function(e,n){if(typeof e==="function"&&n===t){n=e;e=E}var i=this._watchers[e];if(i===t){i=[];this._watchers[e]=i}i.push(n)};P.prototype.unwatch=function(e,n){if(typeof e==="function"&&n===t){n=e;e=E}var i=this._watchers[e];if(i!==t){var r=u(i,n);i.splice(r,1)}};P.prototype.getOptions=function(e){if(e===t){return this._options}for(var n=0;n<this._nodes.length;n++){if(this._nodes[n].dom===e){return this._nodes[n].options}}return null};P.prototype.replaceScope=function(e){e.$=this._scope.$;this._scope=e;return e};P.prototype.destroy=function(){this.unbind(this._rootDomNodes)};function j(e){return new V(e)}V.prototype=new Object;function V(e){this.name="ConsistentException";this.message=e}V.prototype.toString=function(){return"Consistent.js exception: "+this.message}})(window);/*!
 * Consistent.js Expressions 0.9.7
 * @author Karl von Randow
 * @license Apache License, Version 2.0
 */
(function(e,t){if(typeof Consistent==="undefined"){throw"Consistent must be included before consistent-expressions.js"}Consistent.expressionToFunction=function(e){var t=l(e);var n=u(t,false,e);try{return new Function("ctx",n)}catch(i){throw"Error compiling expression: "+e+" => "+n+" ("+i+")"}};Consistent.statementToFunction=function(e){var t=l(e);var n=u(t,true,e);try{return new Function("ctx",n)}catch(i){throw"Error compiling statements: "+e+" => "+n+" ("+i+")"}};var n=0;var i=1;var r=2;var s=3;var o=4;var a=5;var f=6;function l(e){var t=[];var l=0;var u=e.length;var c=n;var b="";while(l<u){var m=e.charAt(l);if(c===n){if(p(m)){c=i}else if(h(m)){c=o}else if(g(m)){c=r}else if(y(m)){c=s}else if(w(m)){c=a}else if(x(m)){c=f}else if(v(m)){throw"Illegal escape character at "+l+": "+e}else if(A(m)){l++;continue}else{throw"Invalid character '"+m+"' at "+l+": "+e}}else if(c===i){if(!d(m)){_();continue}}else if(c===r){if(!g(m)){_();continue}}else if(c===s){_();continue}else if(c===o){if(h(m)){b+=m;l++;_();continue}else if(v(m)){b+=m;l++;m=e.charAt(l)}}else if(c===a){if(!$(m)){_();continue}}else if(c===f){_();continue}b+=m;l++}function _(){if(b.length>0){if(c===i&&S(b)){var e=k(b);if(e!==null){t.push({type:r,text:e})}else{t.push({type:a,text:b})}}else{t.push({type:c,text:b})}}b="";c=n}_();return t}function u(e,t,n){var l=[];var p=[[]];var d=[[]];var h=0;var v,g=e.length;for(v=0;v<g;v++){var y=p[p.length-1];var b=d[d.length-1];var x=e[v];var w=x.type;if(w===i){if(t){var $=v+1<g?e[v+1]:null;if($!==null&&$.type===r&&m($.text)){y.push('ctx.set("'+c(x.text)+'", ');b.unshift(")");var A=_($.text);if(A){y.push('ctx.get("'+c(x.text)+'")');y.push(A)}v++;continue}}y.push('ctx.get("'+c(x.text)+'")')}else if(w===r){if(m(x.text)){throw"Assignment is invalid in expression: "+n}else{y.push(x.text)}}else if(w===o||w===a){y.push(x.text)}else if(w===s){if(x.text==="("){p.push([]);d.push([])}else{if(!y.length||p.length<2){throw"Invalid bracketed expression in expression: "+n}l.push("var __group"+h+" = "+y.join(" ")+b.join(" ")+";");p.pop();d.pop();y=p[p.length-1];y.push("__group"+h);h++}}else if(w===f){if(t){y.push(d[0].join(" ")+";");d[0]=[];var S=u(e.slice(v+1),true,n);y.push(S);break}else{throw"Invalid multiple statements in expression: "+n}}}if(p.length!==1){throw"Unbalanced bracketed expressions in expression: "+n}return l.join(" ")+(v==g?" return ":"")+p[0].join(" ")+d[0].join(" ")+";"}function c(e){return e.replace(/"/g,'\\"')}function p(e){return e>="a"&&e<="z"||e>="A"&&e<="Z"||e==="_"||e==="$"}function d(e){return p(e)||e==="."||e>="0"&&e<="9"}function h(e){return e==="'"||e==='"'}function v(e){return e==="\\"}function g(e){return e==="!"||e==="%"||e==="="||e==="<"||e===">"||e==="*"||e==="/"||e==="+"||e==="-"||e==="^"||e==="&"||e==="?"||e===":"}function y(e){return e==="("||e===")"}function b(e){return e==="="||e==="+="||e==="-="||e==="*="||e==="/="||e==="%="}function m(e){return b(e)||e==="++"||e==="--"}function _(e){if(e==="="){return null}else if(e.length==2&&e.indexOf("=")===1){return e.charAt(0)}else if(e==="++"){return"+1"}else if(e==="--"){return"-1"}else{throw"Unsupported mutation operator: "+e}}function x(e){return e===";"}function w(e){return e>="0"&&e<="9"}function $(e){return w(e)||e=="."}function A(e){return e<=" "}function S(e){return e==="true"||e==="false"||e==="null"||e==="undefined"||e==="and"||e==="or"||e==="not"||e==="lt"||e==="le"||e==="gt"||e==="ge"||e==="eq"||e==="ne"}function k(e){if(e==="and"){return"&&"}else if(e==="or"){return"||"}else if(e==="not"){return"!"}else if(e==="lt"){return"<"}else if(e==="le"){return"<="}else if(e==="gt"){return">"}else if(e==="ge"){return">="}else if(e==="eq"){return"=="}else if(e==="ne"){return"!="}else{return null}}})(window);/*! 
 * Consistent.js jQuery plugin 0.9.7
 * @author Karl von Randow
 * @license Apache License, Version 2.0
 */
(function(e,t,n){var i=e.consistent=t.Consistent;e.fn.consistent=function(){var e,t;if(arguments.length===0){this.each(function(){var t=i.findScopeForNode(this);if(t){if(e&&e!==t){throw"The given nodes have multiple different scopes"}e=t}else if(e){throw"Some of the given nodes have scopes and others don't"}});if(e){return e}else{e=i()}}else{var n=arguments[0];if(i.isScope(n)){e=n;t=arguments.length>1?arguments[1]:null}else if(typeof n==="object"){e=i(n);t=null}else{throw"First argument to $.consistent was not an appropriate type: "+typeof n}}this.each(function(){e.$.bind(this,t)});return e};e(function(){if(i.settings.autoCreateScopes){i.autoCreateScopes()}})})(jQuery,window);
//# sourceMappingURL=consistent-for-jquery.min.js.map